package main

import (
	"context"
	"gitea.pena/PenaDevops/smtpbiz-exporter/internal/app"
	"gitea.pena/PenaDevops/smtpbiz-exporter/internal/initialize"
	"go.uber.org/zap"
	"log"
	"os/signal"
	"syscall"
)

func main() {
	logger, err := zap.NewProduction()
	if err != nil {
		log.Fatalf("can't initialize zap logger: %v", err)
	}

	config, err := initialize.LoadConfig()
	if err != nil {
		logger.Fatal("can't initialize config", zap.Error(err))
	}

	ctx, stop := signal.NotifyContext(context.Background(), syscall.SIGINT, syscall.SIGTERM)
	defer stop()

	if err = app.Run(ctx, logger, *config); err != nil {
		logger.Fatal("can't start app", zap.Error(err))
	}
}
