package initialize

import (
	"github.com/caarlos0/env/v8"
	"github.com/joho/godotenv"
	"log"
)

type Config struct {
	SmtpApiUrl   string `env:"SMTP_API_URL,required"`
	SmtpApiKey   string `env:"SMTP_API_KEY,required"`
	Frequency    int64  `env:"FREQUENCY,required"`
	AdminHttpURL string `env:"ADMIN_HTTP_URL,required"`
}

func LoadConfig() (*Config, error) {
	if err := godotenv.Load(); err != nil {
		log.Print("No .env file found")
	}
	var config Config
	if err := env.Parse(&config); err != nil {
		return nil, err
	}
	return &config, nil
}
