# SMTPbiz-Exporter
## Описание

- SMTPbiz-Exporter - сервис для мониторинга административно важных метрик рассыльщика электронной почты.
- Основная задача - своевременное уведомление об исчерпании пакета писем у рассыльщика, а также предоставление аналитической информации.

## Проблемы

- `Лимиты рассыльщика`: Когда достигается лимит отправки писем, рассылка останавливается. Это приводит к простою, если вовремя не оплатить новый пакет.
- `Аналитика`:
  - Количество писем, попавших в спам.
  - Количество недоставленных писем.
  - Статистика отписок.
  - Распределение аудитории по устройствам, времени и странам.
  - E.T.C.

## Основные функции

- Получение административно важных данных об аккаунте.
- Получение информации о рассылках, статистика.
- Информация о выделенных доменах и ip адресах.
- Получение журнала где хранятся все отправленные письма, с данными о статусах.
- Получение информации об отписках и их причинах.

## Эндпоинты

Ниже приведен список эндпоинтов которые обрабатывает клиент, подробнее в openapi.yaml:

| **Эндпоинт**      | **Описание**                                             |
|--------------------|---------------------------------------------------------|
| `user`            | Данные о аккаунте, административные                      |
| `user/stats`      | Статистика по рассылкам                                  |
| `user/domain`     | Данные о доменах отправителя                             |
| `user/ip`         | Данные о выделенных IP-адресах отправителя               |
| `log/message`     | Журнал отправленных писем (поиск с фильтрами)            |
| `unsubscribe`     | Список пользователей и причин, отписавшихся от рассылок. |

### Предположения по сервису

- Worker который с некой частотой проходит и получает информацию, выгружая в какое-нибудь хранилище.
- Отправка уведомлений об исчерпании тарифов в телеграм.
- Подключение к prometheus для мониторинга.
- `Возможно взаимодействие в другом формате надо UPD.`
